﻿601,100
602,"helloWorldTimeInTM1"
562,"NULL"
586,
585,
564,
565,"eQVz0asgEx4Td=;m4Qn1Ur<d57FLw77RoAl`MyP0eN6^o:I_t;d12[2N=g0SsB3Yii6axZzP>?3;DNQY_U]>6=VtneY\0dv@r0mPapJF8^lI@q5g\cHvE@:LJn\887V?44c0tC3u]X7fwcKpvBrx:_a[3y]9P>n]xolL?Y>h2jlUzdmxFG9ut`c[GlKETT^fgHQP9bH9"
559,1
928,0
593,
594,
595,
597,
598,
596,
800,
801,
566,0
567,","
588,"."
589,","
568,""""
570,
571,
569,0
592,0
599,1000
560,0
561,0
590,0
637,0
577,0
578,0
579,0
580,0
581,0
582,0
603,0
572,256
#****Begin: Generated Statements***
#****End: Generated Statements****

DatasourceASCIIQuoteCharacter='';
DatasourceASCIIDelimiter=Char(9);

cFile = 'datetest.txt';

AsciiOutput(cFile, 'Hello World - TM1 Date Functions' );

#--------------------------------------------------------------------------------------------------------------------------------------------------------------------
# How to use FormatDate
#--------------------------------------------------------------------------------------------------------------------------------------------------------------------
AsciiOutput(cFile, '');
AsciiOutput(cFile, '==========');
AsciiOutput(cFile, 'How to use FormatDate');
AsciiOutput(cFile, '');

sNow = FormatDate( Now());
AsciiOutput(cFile, 'Get the Date without NewDateFormatter', sNow);

sNow = FormatDate( Now(), 'yyyy-MMMM-dd' );
AsciiOutput(cFile, 'Get the Date with Custom Format' , sNow);

#--------------------------------------------------------------------------------------------------------------------------------------------------------------------
# How to use ParseDate
#--------------------------------------------------------------------------------------------------------------------------------------------------------------------
AsciiOutput(cFile, '');
AsciiOutput(cFile, '==========');
AsciiOutput(cFile, 'How to use ParseDate');
AsciiOutput(cFile, '');

sDateInput = '04-01-2020';
AsciiOutput(cFile, 'US Format Date', sDateInput);
nDateInput = ParseDate(sDateInput , 'MM-dd-yyyy');
sDateOutput = FormatDate( nDateInput, 'dd MMMM yyyy'  );
AsciiOutput(cFile, 'source', 'MM-dd-yyyy' , sDateInput);
AsciiOutput(cFile, 'output', 'dd MMMM yyyy' , sDateOutput);

#--------------------------------------------------------------------------------------------------------------------------------------------------------------------
# How to use NewDateFormatter
#--------------------------------------------------------------------------------------------------------------------------------------------------------------------
AsciiOutput(cFile, '');
AsciiOutput(cFile, '==========');
AsciiOutput(cFile, 'How to use NewDateFormatter');
AsciiOutput(cFile, '');

nUTCDateFormatId = NewDateFormatter('en-AU');
sNow = FormatDate( Now(),'',nUTCDateFormatId);
AsciiOutput(cFile, 'Get the Date en-AU', sNow);

nUTCDateFormatId = NewDateFormatter('en-AU','', '','', 'datetime');
sNow = FormatDate( Now(),'',nUTCDateFormatId);
AsciiOutput(cFile, 'Get the Date en-AU datetime', sNow);


nUTCDateFormatId = NewDateFormatter('en-AU','Europe/Berlin', '','', 'datetime');
sNow = FormatDate( Now(),'',nUTCDateFormatId);
AsciiOutput(cFile, 'Get the Date en-AU Europe/Berlin', sNow);

nUTCDateFormatId = NewDateFormatter('en-AU','Europe/Berlin', 'serial','', 'datetime');
sNow = FormatDate( Now(),'',nUTCDateFormatId);
AsciiOutput(cFile, 'Get the Date en-AU Europe/Berlin serial', sNow);

nUTCDateFormatId = NewDateFormatter('en-AU','Europe/Berlin', 'serial','long');
sNow = FormatDate( Now(),'',nUTCDateFormatId);
AsciiOutput(cFile, 'Get the Date en-AU Europe/Berlin serial long', sNow);

nUTCDateFormatId = NewDateFormatter('en-AU','Europe/Berlin', 'serial','long', 'datetime');
sNow = FormatDate( Now(),'',nUTCDateFormatId);
AsciiOutput(cFile, 'Get the Date en-AU Europe/Berlin serial long datetime', sNow);

#--------------------------------------------------------------------------------------------------------------------------------------------------------------------
# Get Time
#--------------------------------------------------------------------------------------------------------------------------------------------------------------------
AsciiOutput(cFile, '');
AsciiOutput(cFile, '==========');
AsciiOutput(cFile, 'Get Time');
AsciiOutput(cFile, '');

nUTCDateFormatId = NewDateFormatter('en-AU','','','','datetime');
sNow = FormatDate( Now(),'',nUTCDateFormatId);
AsciiOutput(cFile, 'Get the Datetime', sNow);

nUTCDateFormatId = NewDateFormatter('en-AU','Europe/London','','','datetime');
sNow = FormatDate( Now(),'',nUTCDateFormatId);
AsciiOutput(cFile, 'Get the Datetime Europe/London', sNow);


#--------------------------------------------------------------------------------------------------------------------------------------------------------------------
# Get Date from Day Number depending from pattern
#--------------------------------------------------------------------------------------------------------------------------------------------------------------------
AsciiOutput(cFile, '');
AsciiOutput(cFile, '==========');
AsciiOutput(cFile, 'Get Date from Day Number depending from pattern');
AsciiOutput(cFile, '');

# Create a Format Date ID
nUTCDateFormatId = NewDateFormatter('en-AU', 'Etc/UTC', 'serial', 'medium', 'datetime');
sDatePattern = 'yyyy-MM-dd H:mm:dd';
sNow = FormatDate( Now(), sDatePattern, nUTCDateFormatId );
AsciiOutput(cFile, sDatePattern, sNow);


#--------------------------------------------------------------------------------------------------------------------------------------------------------------------
# Play with the format types and locales to get the date in different langages
#--------------------------------------------------------------------------------------------------------------------------------------------------------------------
AsciiOutput(cFile, '');
AsciiOutput(cFile, '==========');
AsciiOutput(cFile, 'Different format Types');
AsciiOutput(cFile, '');

sLocale = 'en-us';
sFormatType = 'short';
nNewFormatId = NewDateFormatter(sLocale, 'Etc/UTC', 'serial', sFormatType, 'datetime');
sDate = FormatDate( Now(),'',nNewFormatId );
AsciiOutput(cFile, sLocale, sFormatType, sDate);

sFormatType = 'medium';
nNewFormatId = NewDateFormatter(sLocale, 'Etc/UTC', 'serial', sFormatType, 'datetime');
sDate = FormatDate( Now(),'',nNewFormatId );
AsciiOutput(cFile, sLocale, sFormatType, sDate);

sFormatType = 'long';
nNewFormatId = NewDateFormatter(sLocale, 'Etc/UTC', 'serial', sFormatType, 'datetime');
sDate = FormatDate( Now(),'',nNewFormatId );
AsciiOutput(cFile, sLocale, sFormatType, sDate);

sFormatType = 'full';
nNewFormatId = NewDateFormatter(sLocale, 'Etc/UTC', 'serial', sFormatType, 'datetime');
sDate = FormatDate( Now(),'',nNewFormatId );
AsciiOutput(cFile, sLocale, sFormatType, sDate);


AsciiOutput(cFile, '');
AsciiOutput(cFile, '==========');
AsciiOutput(cFile, 'Let''s Play with the locales to get the date in different langages');
AsciiOutput(cFile, '');


sLocale = 'en-gb';
nNewFormatId = NewDateFormatter(sLocale, 'Etc/UTC', 'serial', 'full', 'datetime');
sDate = FormatDate( Now(),'',nNewFormatId );
AsciiOutput(cFile, sLocale, sDate);


sLocale = 'fr-FR';
# Get a new date formatter with the locale defined above
nNewFormatId = NewDateFormatter(sLocale, 'Etc/UTC', 'serial', 'full', 'datetime');
#Format the date in the current locale, using the new date formatter
sDate = FormatDate( Now(), '', nNewFormatId );
AsciiOutput(cFile, sLocale, sDate);

sLocale = 'de-DE';
nNewFormatId = NewDateFormatter(sLocale, 'Etc/UTC', 'serial', 'full', 'datetime');
sDate = FormatDate( Now(), '', nNewFormatId );
AsciiOutput(cFile, sLocale, sDate);

sLocale = 'no-no';
nNewFormatId = NewDateFormatter(sLocale, 'Etc/UTC', 'serial', 'full', 'datetime');
sDate = FormatDate( Now(), '', nNewFormatId );
AsciiOutput(cFile, sLocale, sDate);

sLocale = 'nl-nl';
nNewFormatId = NewDateFormatter(sLocale, 'Etc/UTC', 'serial', 'full', 'datetime');
sDate = FormatDate( Now(), '', nNewFormatId );
AsciiOutput(cFile, sLocale, sDate);

sLocale = 'zu';
nNewFormatId = NewDateFormatter(sLocale, 'Etc/UTC', 'serial', 'full', 'datetime');
sDate = FormatDate( Now(), '', nNewFormatId );
AsciiOutput(cFile, sLocale, sDate);


AsciiOutput(cFile, '');
AsciiOutput(cFile, ' ==> A date can be written in any language, even in Zulu (zu). No need to store these translations');

#--------------------------------------------------------------------------------------------------------------------------------------------------------------------
# Daylight saving management 
#--------------------------------------------------------------------------------------------------------------------------------------------------------------------


AsciiOutput(cFile, '');
AsciiOutput(cFile, '==========');
AsciiOutput(cFile, 'Daylight saving management');
AsciiOutput(cFile, '');

# Date to convert
sDateSource = '2020-04-01 20:00:00 PM';

# Define System Local Time DateFormatter 
nSydneyDateFormatId = NewDateFormatter('en-AU', 'Australia/Sydney', 'serial', 'medium', 'datetime');

#Get the TimeValue For a specific date
sDateFormatterInput = 'yyyy-MM-dd HH:mm:ss';
nSydneyDateTime = ParseDate(sDateSource , sDateFormatterInput, nSydneyDateFormatId);

# (re) Calculate the System local Time
sDateFormatter = 'yyyy-MM-dd HH:mm:ss a z';
sSydneyTime = FormatDate( nSydneyDateTime, sDateFormatter ,nSydneyDateFormatId );

# Define System Local Time DateFormatter 
nLondonDateFormatId = NewDateFormatter('en-AU', 'Europe/London', 'serial', 'medium', 'datetime');

# Get Report time
sLondonTime = FormatDate( nSydneyDateTime, sDateFormatter, nLondonDateFormatId  );

AsciiOutput(cFile, 'Input date', sDateSource);
AsciiOutput(cFile, 'Sydney Datetime', sSydneyTime  );
AsciiOutput(cFile, 'London Datetime', sLondonTime );

nLondonDateTime = ParseDate(sLondonTime , nLondonDateFormatId);

nDelta = nSydneyDateTime - nLondonDateTime;
sDelta = FormatDate( nDelta, 'H');

AsciiOutput(cFile, 'Time difference Sydney vs London:', sDelta, 'Hours' );

AsciiOutput(cFile, '');
AsciiOutput(cFile, 'The day after, the daylight saving happened in Sydney');

# Same code with new Date

sDateSource = '2020-10-01 20:00:00 PM';

# Define System Local Time DateFormatter 
nSydneyDateFormatId = NewDateFormatter('en-AU', 'Australia/Sydney', 'serial', 'medium', 'datetime');

#Get the TimeValue For a specific date
sDateFormatterInput = 'yyyy-MM-dd HH:mm:ss';
nSydneyDateTime = ParseDate(sDateSource , sDateFormatterInput, nSydneyDateFormatId);

# (re) Calculate the System local Time
sDateFormatter = 'yyyy-MM-dd HH:mm:ss a z';
sSydneyTime = FormatDate( nSydneyDateTime, sDateFormatter ,nSydneyDateFormatId );

# Define System Local Time DateFormatter 
nLondonDateFormatId = NewDateFormatter('en-AU', 'Europe/London', 'serial', 'medium', 'datetime');

# Get Report time
sLondonTime = FormatDate( nSydneyDateTime, sDateFormatter, nLondonDateFormatId  );

AsciiOutput(cFile, 'Input date', sDateSource);
AsciiOutput(cFile, 'Sydney Datetime', sSydneyTime  );
AsciiOutput(cFile, 'London Datetime', sLondonTime );

nLondonDateTime = ParseDate(sLondonTime , nLondonDateFormatId);

nDelta = nSydneyDateTime - nLondonDateTime;
sDelta = FormatDate( nDelta, 'H');

AsciiOutput(cFile, 'Time difference Sydney vs London:', sDelta, 'Hours' );

AsciiOutput(cFile, '');
AsciiOutput(cFile, 'The day after, the daylight saving happened in Sydney');
AsciiOutput(cFile, '  => London move from the GMT+1 to the GMT timezone');
573,2
#****Begin: Generated Statements***
#****End: Generated Statements****
574,2
#****Begin: Generated Statements***
#****End: Generated Statements****
575,2
#****Begin: Generated Statements***
#****End: Generated Statements****
576,
930,0
638,1
804,0
1217,0
900,
901,
902,
938,0
937,
936,
935,
934,
932,0
933,0
903,
906,
929,
907,
908,
904,0
905,0
909,0
911,
912,
913,
914,
915,
916,
917,0
918,1
919,0
920,50000
921,""
922,""
923,0
924,""
925,""
926,""
927,""
